#!/usr/bin/perl -w
# Requires perl 5
# KonvCHRS 0.1



$dir = 'ram:test/';                 # Hr ligger dina paketfiler
$ext = '.PKT\Z';                    # Regexp fr vad dina filer har fr filslut
$chrsdir = 'dh0:Coding/Perl/CHRS/'; # Hr ligger teckentabllerna
$tochrs = "IBMPC";                  # Den hr teckenuppsttningen vill du konvertera till



while (<$dir*>) {
  my($filnamn) = $_;
  if ($filnamn =~ /$ext/i) {

      # Skall bort, men behver vara globala...
    $msg = "";                     # Innehller inlst meddelandedata
    $lastmsg = 0;                  # r sista meddelandet inlst?
    $readlength = 4096;            # Hur mycket som lses in t gngen
				   # Fr inte vara mindre n 58!


    my(%headerinfo, @texter);

    open(PKT, "<$filnamn") || die "Kunde inte ppna filen $filnamn";
    open(tmpPKT, ">$filnamn.tmp") || die "Kunde inte ppna filen $filnamn.tmp";

    &getkonv(\@chrs);

    &getheader(*PKT, \%headerinfo);
    &writeheader(*tmpPKT, \%headerinfo);

    while ($lastmsg == 0) {
      &getmsg(*PKT, \%texter);
      $texter{fromUserName} = &konv($texter{fromUserName}, \@chrs, $texter{Kludge}{"CHRS:"});
      $texter{toUserName} = &konv($texter{toUserName}, \@chrs, $texter{Kludge}{"CHRS:"});
      $texter{subject} = &konv($texter{subject}, \@chrs, $texter{Kludge}{"CHRS:"});
      $texter{text} = &konv($texter{text}, \@chrs, $texter{Kludge}{"CHRS:"});

      &writemsg(*tmpPKT, \%texter);
    }

    &writepktend(*tmpPKT);

    close(PKT);
    close(tmpPKT);

    unlink $filnamn;
    rename "$filnamn.tmp", $filnamn;
  }
}


sub getheader {
  my($PKT, $hi) = @_;

  &readpkt($PKT);
  my($header) = substr($msg, 0, 58);
  $msg = substr($msg, 58);

  ($hi->{OrgNode}, $hi->{DstNode}, $hi->{Year}, $hi->{Month}, $hi->{Day},
   $hi->{Hour}, $hi->{Min}, $hi->{Sec}, $hi->{Baud}, $hi->{PktVer},
    $hi->{OrgNet}, $hi->{DstNet}, $hi->{PrdCodL}, $hi->{PVMajor},
     $hi->{Password}, $hi->{QOrgZone}, $hi->{QDstZone}, $hi->{Filler},
      $hi->{CapValid}, $hi->{PrdCodH}, $hi->{PVMinor}, $hi->{CapWord},
       $hi->{OrigZone}, $hi->{DestZone}, $hi->{OrigPoint}, $hi->{DestPoint},
	$hi->{ProdData}) = unpack("v12C2a8v4C2v5V", $header);

  $hi->{RawHeader} = $header;

  if (not $hi->{PktVer} == 2) {
    warn("Filen $filnamn r inte en paketfil.\n");
    $lastmsg = 1;
    $hi = undef;
    return;
  }
}


sub getmsg {
  my($PKT, $t) = @_;
  my($msghead) = "";

  return if &readpkt($PKT, 14);

  if (length($msg) < 14) {
    if ($lastmsg) {
      warn("Frsk att lsa meddelande, trots slut p fil i paketet $filnamn\n");
    }
    else {
      warn("Paketet $filnamn r skadat. (Fr tidigt slut)\n");
      $lastmsg = 1;
    }
    return;
  }

  $msghead = substr($msg, 0, 14);
  $msg = substr($msg, 14);

  while (not ($msg =~
     /\A(.{19})\0([^\0]*)\0([^\0]*)\0([^\0]*)\0([^\0]*)\0/)) {
    return if &readpkt($PKT);
  }

  $msg =~ /\A(.{19})\0([^\0]*)\0([^\0]*)\0([^\0]*)\0([^\0]*)\0/;
  $msg = $';
  $t->{DateTime} = $1;
  $t->{toUserName} = $2;
  $t->{fromUserName} = $3;
  $t->{subject} = $4;
  $t->{text} = $5;
  ($t->{PktVer}, $t->{origNode}, $t->{destNode}, $t->{origNet},
    $t->{destNet}, $t->{Attribute}, $t->{cost}) = unpack("v7", $msghead);

  if (not $t->{PktVer} == 2) {
    warn("Paketet $filnamn r skadat. (Fel paketversion)\n");
    $lastmsg = 1;
    return;
  }

  my($msgbody) = $t->{text};
  if ($msgbody =~ s/\AAREA:([^\015]*)//i) {
    $t->{Kludge}{"AREA:"} = $1;
  }
  while ($msgbody =~ s/(\A|\015)\001(\S*) ([^\015]*)/$1/) {
    $t->{Kludge}{$2} = $3;
  }

  return if &readpkt($PKT, 2);

  $lastmsg = 1 if ($msg =~ /\A\0\0/);          # Slut p paketet
}


sub readpkt {
  my($PKT, $lowbyte);
  if ($#_ == 1) {
    ($PKT, $lowbyte) = @_;
  }
  else {
    ($PKT) = @_;
    $lowbyte = 2000000000;      # Behver gras om nr 2GB stora meddelanden blir verklighet...
  }

  my($in) = "";              # Tilldelningen tar bort en varning vid lsning

  if (length($msg) < $lowbyte) {
    if (eof($PKT)) {
      warn("Paketet $filnamn r skadad. (Felaktigt meddelande)\n");
      $lastmsg = 1;
      return 1;
    }
    read($PKT, $in, $readlength);
    $msg .= $in;
  }
  return 0;
}

sub writeheader {
  my($PKT, $hi) = @_;

  print $PKT ($hi->{RawHeader});
}

sub writemsg {
  my($PKT, $t) = @_;

  my($msghead) = pack("v7", $t->{PktVer}, $t->{origNode}, $t->{destNode},
    $t->{origNet}, $t->{destNet}, $t->{Attribute}, $t->{cost});

  print $PKT ($msghead);
  print $PKT ($t->{DateTime} . "\0");
  print $PKT ($t->{toUserName} . "\0");
  print $PKT ($t->{fromUserName} . "\0");
  print $PKT ($t->{subject} . "\0");
  print $PKT ($t->{text} . "\0");
}

sub writepktend {
  my($PKT) = @_;

  print $PKT ("\0\0");
}

sub getkonv {
  my($chrs) = @_;
  my($in) = "";              # Tilldelningen tar bort en varning vid lsning
  my($i) = 0;

  while (<$chrsdir*>) {
    my($filnamn) = $_;

    open(CHRSPKT, "<$filnamn") || die "Kunde inte ppna filen $filnamn";

    read(CHRSPKT, $in, 1024);    # 1024 i lngd ska alltid rcka utan problem...

    if ($in =~ /\A(.+)\0(.+)\0/) {
      my($from) = $1;
      my($to) = $2;
      $in = $';
      if ($to =~ /$tochrs/) {
	$chrs->[$i]{From} = $from;
	$chrs->[$i]{Tabell} = $in;
	$i++;
      }
    }
    close(CHRSPKT);
  }
}

sub konv {
  my($msg, $konv, $chrs) = @_;
  my($chrsset, $i, $j);
  my($out) = $msg;

  for ($i = 0; $i < $#$konv; $i++) {
    if ($chrs =~ /$konv->[$i]{From}/) {
      $msg =~ s/(\A|\015)\001CHRS\: [^\015]*\015/$1/; # Tar bort felaktiga kludgar
      $chrsset = $konv->[$i]{Tabell};
      $out = "";
      for ($i = 0; $i < length($msg); $i++) {
	$out = $out . substr($chrsset, ord(substr($msg, $i, 1))-1, 1);
      }
      return $out;
    }
  }

  return $out;
}

